# rest.js Documentation


## Core Facilities

[Interceptors](interceptors.md)

How interceptors are applied to clients with configuration.  Descriptions for all interceptors provided with rest.js including configuration properties. How to create custom interceptors using the interceptor factory with links to real interceptors that demonstrate different interceptor characteristics.

[Clients](clients.md)

Description of built in clients including the default client and client specific properties.

[Common Interfaces](interfaces.md)

Common methods and properties for request/response objects, clients and interceptors.


## RESTful Concepts

[Content Negotiation](mime.md)

Support for serializing/deserializing objects to/from HTTP requests/responses.


## Optional Libraries

[wire.js](wire.md)

Declarative client configuration with wire.js.


[Dojo Toolkit](dojo.md)

Support for the Dojo Toolkit Store APIs
